// ====================================================================
// Holger Nahrstaedt
// INRIA 2010
// Template edflib
// This file is released into the public domain
// ====================================================================
//
//
function  [edf_data]=edfread_samples(filename,edfsignal,n)


    [lhs,rhs]=argn(0);
    if rhs == 0 then
  	 error("Expect at least one argument")
    end
    if rhs > 3 then
  	 error("Maximal 3 arguments!")
    end 

     try
	edf_header=edfopen_file_readonly(filename,0);
     catch
      edf_data=[];
      error(lasterror());
     end
     try
       if (rhs ==1) then 
	  edfsignals=1:edf_header("edfsignals");
	  n=edf_header("smp_in_file")(1);
	  edf_data=zeros(n,edf_header("edfsignals"));
	  for i=edfsignals
	      if edf_header("smp_in_file")(i) ~= n then
                  edf_close(edf_header("handle"));
		error("The number of samples must be the same for all edfsignals! Please read the samples for each edfsignal seperatly!");
              end
	      edf_data(:,i)=edfread_physical_samples(edf_header("handle"),i,n);
	  end

	elseif (rhs == 2) then
	  if (min(edfsignal)<1 | max(edfsignal)>edf_header("edfsignals")) then
                edf_close(edf_header("handle"));
	      error("Choose an edfsignal beetween 1 and %d !",edf_header("edfsignals"));
	  end;
          if (size(edfsignal,'*')>1) then
	      n=edf_header("smp_in_file")(edfsignal(1));
	      edf_data=zeros(n,size(edfsignal,'*'));
	      for i=edfsignal
	        if edf_header("smp_in_file")(i) ~= n then
                    edf_close(edf_header("handle"));
		  error("The number of samples must be the same for all edfsignals! Please read the samples for each edfsignal seperatly!");
                end
	        edf_data(:,i)=edfread_physical_samples(edf_header("handle"),i,n);
	      end
          else
             n=edf_header("smp_in_file")(edfsignal);
	     edf_data=zeros(n,1);
	     edf_data=edfread_physical_samples(edf_header("handle"),edfsignal,n);
          end;
	else //rhs==3
	  if (edfsignal<1 | edfsignal>edf_header("edfsignals")) then
                edf_close(edf_header("handle"));
	      error("Choose an edfsignal beetween 1 and %d !",edf_header("edfsignals"));
	  end;
	  if (n<1) then
             n=edf_header("smp_in_file")(edfsignal);
          end;
	  if (n>edf_header("smp_in_file")(edfsignal)) then
                  edf_close(edf_header("handle"));
                error("The parameter n is to big!");
          end
          edf_data=zeros(n,1);
	  edf_data=edfread_physical_samples(edf_header("handle"),edfsignal,n);
	end
        edf_close(edf_header("handle"));
catch
  edf_close(edf_header("handle"));
  error(lasterror());
end


endfunction
// ====================================================================
