//	Copyright (c) 2010 - Holger Nahrstaedt
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
function  edfwrite_samples(handle,sample_freq,data)

    [lhs,rhs]=argn(0);
    if rhs < 3 then
  	 error("Expect at least three arguments")
    end
   if (type(data)==1)
    signals = size(data,2);
   elseif (type(data)==15)
    signals = size(data);
   else
    error("Wrong data type for data!");
   end;

   if (size(sample_freq,'*')==1) then
	sample_freq=ones(1,signals)*sample_freq;
   else
      if (type(data)==1) then 
	if (mean(sample_freq)~=max(sample_freq))
	  error("sample_freq of all signals must be equal!");
	end
      end
   end

   if (size(sample_freq,'*') ~= signals) then
	  error("dimension of sample_freq and data doesnot fit!");
   end;
 if (type(data)==1)
  sek=ceil(size(data,1)/sample_freq(1));
  data=[data;zeros(sek*sample_freq(1)-size(data,1),signals)];

  for (i=1:sek) 
	  ind=1+((i-1)*sample_freq(1)):sample_freq(1)+((i-1)*sample_freq(1));
	  edf_blockwrite_psamples(handle,data(ind,:));
  end;
 elseif (type(data)==15) //list
  sek=zeros(1,signals);
  for (i=1:signals)
    sek(i)=ceil(size(data(i),'*')/sample_freq(i));
    data(i)=[data(i);zeros(sek(i)*sample_freq(i)-size(data(i),'*'),1)];
  end

  if (mean(sek)~=max(sek))
	  error("time length  of all signals must be equal!");
  end
  sek=sek(1);

  for (i=1:sek) 
    for (j=1:signals)
	  ind=1+((i-1)*sample_freq(j)):sample_freq(j)+((i-1)*sample_freq(j));
	  edfwrite_psamples(handle,data(j)(ind));
    end;
  end;
 end
endfunction
// ====================================================================
